#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <limits.h>

void endMark() { putchar('-'); putchar('1'); }

main(int argc, char* argv[]) {	// binFileToDec file [ start[ count]]

	if ((argc < 2) || (argc > 4)) { endMark(); return 0; }

	int fd;
	if ((fd = open(argv[1], O_RDONLY)) == -1) { endMark(); return 0; }

	long start = 0;
	if (argc > 2) { start = strtol(argv[2], NULL, 10); }

	long count = 0x7FFFFFFFL;
	if (argc > 3) { count = strtol(argv[3], NULL, 10); }

	char* dec = "0123456789";
    int c, h, t, r, n, i;

    int BUFFSIZE = 1024;
    char buffer[BUFFSIZE];

	if (lseek(fd, start, 0) == -1)  { close(fd); endMark(); return 0; }

	while (( n = read(fd, buffer, BUFFSIZE) ) > 0) {
		i = 0;

		while ((count > 0) && ( n > 0)) {
			c = buffer[i] & 0xFF;
        	h = c / 100; if (h != 0) putchar(dec[h]);
        	r = c % 100;
        	t = r / 10;  if ((h != 0) || (t != 0)) putchar(dec[t]);
        	r = r % 10;  putchar(dec[r]);
        	putchar(' ');
        	count--;
        	n--;
        	i++;
        }
        if (count == 0) { break; }
	}
	close(fd);
	endMark();
	return 0;
}
