#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <limits.h>

int decode(int hi, int lo)
{
	int result = 0;
	
	if (('0' <= hi) && (hi <= '9')) { result = (hi - '0'); }
	else if (('A' <= hi) && (hi <= 'F')) { result = (hi - 'A' + 10); }
	result *= 16;
	
	if (('0' <= lo) && (lo <= '9')) { result += (lo - '0'); }
	else if (('A' <= lo) && (lo <= 'F')) { result += (lo - 'A' + 10); }
	return result;
}

void endMark() { putchar('-'); putchar('1'); }

main(int argc, char* argv[]) { // hexFileToBin file[ start[ count[ hexData]]]

	if ((argc < 2) || (argc > 5))  { endMark(); return 0; }
	
	long start = 0;
	if (argc > 2) { start = strtol(argv[2], NULL, 10); }
	
	int mode = O_CREAT | O_TRUNC | O_WRONLY;
	if (start) { mode = O_WRONLY; }

	int fd;
	if ( (fd = open(argv[1], mode, 0644) ) == -1) { endMark(); return 0; }

	long count = 0x7FFFFFFFL;
	if (argc > 3) { count = strtol(argv[3], NULL, 10); }

	char* data = "";
	if (argc > 4) { data = argv[4]; }
	
    int n;
    char hi, lo;
    
    int BUFFSIZE = 1024;
    char buffer[BUFFSIZE];

	if (lseek(fd, start, 0) == -1)  { close(fd); endMark(); return 0; }
	
	while ((*data) && (count > 0))
	{
		n = 0;
		while ((*data) && (count > 0) && (n < BUFFSIZE))
		{
			hi = *data; data++;
			lo = *data; if (lo) data++;
			buffer[n++] = decode(hi, lo);
			count--;
		}
		if (n) write(fd, buffer, n);
	}
	close(fd);
	return 0;
}
