/*
	Hex Display - A Hex Display Widget
	Copyright © 2008-2009 Harry Whitfield

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the Free
	Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
	MA  02110-1301  USA
	
	Hex Display - version 1.0.1
	5 August, 2009
	Copyright © 2008-2009 Harry Whitfield
	mailto:g6auc@arrl.net
*/

/*global mainWindow, selectTheEntry, dragDropped, frm, selectEntry,
		 selectionBar, Frame_topMiddle, Frame_bottomMiddle, Frame_topRight, Frame_rightMiddle,
		 Frame_bottomRight, Frame_leftMiddle, Frame_bottomLeft, bg, FrameDragBox, vsb, theInput
		 FileName, hsb, goHome, eprint, goDown, goUp, goEnd,
		 saveFile, testFile, dumpFile, displayLicense
		 
*/

/*members anchorStyle, appendChild, availHeight, checked, color, 
    colorize, contextMenuItems, data, editable, enabled, event, fontFamily, 
    hOffset, height, index, lastIndexOf, length, onClick, onDragDrop, 
    onMouseDrag, onSelect, opacity, open, platform, push, removeChild, 
    replace, scrollbar, size, style, substring, title, tooltip, vOffset, 
    visible, width
*/

var systemPlatform = system.platform;
// systemPlatform = "windows";

var minW = 385, maxW = 528, minH = 251, maxH = 2064;
var width = minW, height = minH;

var theText = {};
theText.data = "";

var entryFrameHOffset  =  0;	// <!--frame name="entryFrame" hOffset="28" vOffset="0" width="376" height="104" />
var entryFrameWidth    = 528;
var nameDisplayWidth   = 528;

var entryFrame    = null;
var vDelta        =    2;		// tweak entry frame vertical position - macintosh value

if (system.platform == "windows") {
	vDelta = 2;
}		// in case a different value is needed on Windows.

var entryDBHeight =   16;		// entry frame height
    	
var minEntries    =    14;
var maxEntries    =    128;
var minDBHeight   =     0;
var headDBHeight  =     0;
var midDBHeight   =    minEntries * entryDBHeight + headDBHeight + vDelta;
var maxDBHeight   =    screen.availHeight - 100;		// was maxEntries*entryDBHeight + headDBHeight + vDelta;

var theKeys    = null;			// to keep refs to the key (title) fields of the entry frames
var oldSelection = -1;			// last selected entry
var lastEntry    = 0;

var dataBase   = [];
var gPath = null, gEndOfFile;

var helpFile = function () {
	filesystem.open('Resources/Help.pdf');
};

var licenseFile = function () {
	displayLicense();
};

var baseMenu   = ["Home", "PageDown", "PageUp", "End", "-", "Save As...", "Save Test File As...",
				  "Write Hex Dump As...", "-", "Display Help Information", "Display License Agreement..."];
var menuAction = [goHome, goDown, goUp, goEnd, null, saveFile, testFile, dumpFile, null, helpFile, licenseFile];

var contextMenuItems = [];	

function newFrame(window, hOffset, vOffset, width, height) {
	var frm = new Frame(window);
	frm.hOffset = hOffset;
	frm.vOffset = vOffset;
	frm.width = width;
	frm.height = height;
	return frm;
}

function newTextArea(hOffset, vOffset, width, height, scrollbar, editable, fontFamily, size, color, opacity) {
	var ta = new TextArea();
	ta.hOffset = hOffset;
	ta.vOffset = vOffset;
	ta.width = width;
	ta.height = height;
	ta.scrollbar = scrollbar;
	ta.editable = editable;
	ta.style.fontFamily = fontFamily;
	ta.size = size;
	ta.color = color;
	ta.opacity = opacity;
	return ta;
}

function newText(hOffset, vOffset, width, height, anchorStyle, fontFamily, size, color, opacity) {
	var tx = new Text();
	tx.hOffset = hOffset;
	tx.vOffset = vOffset;
	tx.width = width;
	tx.height = height;
	tx.anchorStyle = anchorStyle;
	tx.style.fontFamily = fontFamily;
	tx.size = size;
	tx.color = color;
	tx.opacity = opacity;
	return tx;
}

function newContextMenuItem(title, onSelect, enabled, checked) {
	var o = new MenuItem();
	o.title    = title;
	o.onSelect = onSelect;
	o.enabled  = enabled;
	o.checked  = checked;
	return o;
}

function newEntry(i, keyText) {
	var entry   = newFrame(mainWindow, 0, entryDBHeight * i + vDelta, entryFrameWidth, entryDBHeight);
	entryFrame.appendChild(entry);
	var key     =     newText(0,   0, nameDisplayWidth, entryDBHeight, "topLeft", "Monaco, 'Courier New', monospace", 12, "#FFFFFF", 255);
//	var key     = newTextArea(0,   0, nameDisplayWidth, entryDBHeight, false, false, "Monaco, 'Courier New', monospace", 12, "#FFFFFF", 255);
	theKeys[i]  = key;
	key.index   = i;
	key.data    = keyText;
	entry.tooltip = "";
	key.onClick = selectTheEntry;
	key.onDragDrop = dragDropped;
	entry.appendChild(key);
}

function makeDisplay(dataBase) {		// constructs the entryFrame and populates it with data from the database
	if (entryFrame !== null) {
		frm.removeChild(entryFrame);
		entryFrame = null;
		theKeys    = null;
	}
	entryFrame = newFrame(mainWindow, entryFrameHOffset, 0, entryFrameWidth, frm.height);	// <frame name="entryFrame" hOffset="23" vOffset="0" width="392" height="104">
	theKeys    = [];
	frm.appendChild(entryFrame);
    var i;
   	if (dataBase.length !== 0) {
   		maxEntries = dataBase.length;
   	} else {
   		maxEntries = minEntries;
   	}
   	if (maxEntries < minEntries) {
   		maxEntries = minEntries;
   	}
	var dbHeight = frm.height;
	if (dataBase.length !== 0) {
		dbHeight = minEntries * entryDBHeight;
		if (entryDBHeight * dataBase.length > dbHeight) {
			dbHeight = entryDBHeight * dataBase.length;
		}
		lastEntry = dataBase.length - 1;
		entryFrame.height = dbHeight;
		for (i = 0; i < dataBase.length; i += 1) {
			newEntry(i, dataBase[i]);
		}
		selectEntry(-1, 0, maxW, "#000000", "#FF9900");
	} else {
		entryFrame.height = minEntries * entryDBHeight;
	}
}

function selectEntry(i, hOffset, width, color, colorize) {	// called when entry frames are clicked, -1 to deselect all entries
	selectionBar.hOffset = hOffset;
	selectionBar.width = width;
	selectionBar.colorize = colorize;
	if (i >= 0) {
		selectionBar.vOffset = entryDBHeight * i;
	}
	selectionBar.visible = (i >= 0);
	if (theKeys !== null) {
		if ((oldSelection >= 0) && theKeys[oldSelection]) {
			theKeys[oldSelection].color = "#FFFFFF";
		}
		if ((i >= 0) && theKeys[i]) {
			theKeys[i].color = color;
		}
	}
	oldSelection = i;
	updateNow();
}

function selectTheEntry() {
	selectEntry(this.index, 0, maxW, "#000000", "#FF9900");
}

////////////////////////////////////////////////////////////////////////////////////////////////////		

function resize(x, y) {
	if (x > maxW) {
		x = maxW;
	}
	if (x < minW) {
		x = minW;
	}
	if (y > maxH) {
		y = maxH;
	}
	if (y < minH) {
		y = minH;
	}
	mainWindow.width  = x +  64;
	mainWindow.height = y +  96;

	Frame_topMiddle.width      = Frame_bottomMiddle.width   = x;
	Frame_topRight.hOffset     = Frame_rightMiddle.hOffset  = Frame_bottomRight.hOffset  = x + 32;
	Frame_leftMiddle.height    = Frame_rightMiddle.height   = y;
	Frame_bottomLeft.vOffset   = Frame_bottomMiddle.vOffset = Frame_bottomRight.vOffset  = y + 32;

	bg.width             = x + 47;
	bg.height            = y + 19;
	FrameDragBox.hOffset = x + 42;
	FrameDragBox.vOffset = y + 70;
	
	hsb.width  = frm.width  = x + 15;
	vsb.height = frm.height = y - 13;
	
	vsb.hOffset = frm.width  + 24;
	hsb.vOffset = frm.height + 37;
	
	theInput.vOffset = hsb.vOffset + 25;
	theInput.width   = hsb.width;
	FileName.width   = x + 15;
}

function frameResize() {
	resize(system.event.hOffset - 42, system.event.vOffset - 70);
}

function frameClose() {
	closeWidget();
}

function dragDropped() {
	var path, idx;
	var n = system.event.data.length;
	var dropData = [];
	for (var i = 0; i < n; i += 1) {
		dropData[i] = system.event.data[i];
	}
	var dropType = dropData[0];
	if (dropType == "filenames") {				
		for (i = 1; i < 2; i += 1) {
			path = dropData[i].replace(/\\/g, "/");		// in case we get back-slashes on Windows
			path = resolvePath(path);					// in case it is an alias
			gPath = path;
			idx = path.lastIndexOf('/');
			if (idx >= 0) {
				path = path.substring(idx + 1);
			}
			FileName.data = path;
			gEndOfFile = null;
			dataBase = [];
			makeDisplay(dataBase);
			goHome();
		}
	} else {
		beep();
		eprint("dragDropped: Invalid dropType: " + dropType);
	}
	dropData = null;
}

frm.onDragDrop  = dragDropped;
FrameDragBox.onMouseDrag = frameResize;

var m;
for (var k = 0; k < baseMenu.length; k += 1) {
	m = newContextMenuItem(baseMenu[k], menuAction[k], true, false);
	contextMenuItems.push(m);
}

mainWindow.contextMenuItems = contextMenuItems;
